<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfString9 ArrayType
 * @subpackage Arrays
 */
class ArrayOfString9 extends AbstractStructArrayBase
{
    /**
     * The DestinationZone
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $DestinationZone;
    /**
     * Constructor method for ArrayOfString9
     * @uses ArrayOfString9::setDestinationZone()
     * @param string[] $destinationZone
     */
    public function __construct(array $destinationZone = array())
    {
        $this
            ->setDestinationZone($destinationZone);
    }
    /**
     * Get DestinationZone value
     * @return string[]|null
     */
    public function getDestinationZone()
    {
        return $this->DestinationZone;
    }
    /**
     * Set DestinationZone value
     * @throws \InvalidArgumentException
     * @param string[] $destinationZone
     * @return \ArrayType\ArrayOfString9
     */
    public function setDestinationZone(array $destinationZone = array())
    {
        foreach ($destinationZone as $arrayOfString9DestinationZoneItem) {
            // validation for constraint: itemType
            if (!is_string($arrayOfString9DestinationZoneItem)) {
                throw new \InvalidArgumentException(sprintf('The DestinationZone property can only contain items of string, "%s" given', is_object($arrayOfString9DestinationZoneItem) ? get_class($arrayOfString9DestinationZoneItem) : gettype($arrayOfString9DestinationZoneItem)), __LINE__);
            }
        }
        $this->DestinationZone = $destinationZone;
        return $this;
    }
    /**
     * Add item to DestinationZone value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfString9
     */
    public function addToDestinationZone($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The DestinationZone property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DestinationZone[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DestinationZone
     */
    public function getAttributeName()
    {
        return 'DestinationZone';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfString9
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
